/**
  ******************************************************************************
  * Ten Tep          :   adc.c
  * Tac Gia          :   LE ANH QUANG
  * Cong Ty          :   MinhHaGroup
  * Website          :   MinhHaGroup.com
  * Phien Ban        :   V1.0.0
  * Ngay             :   12-10-2012
  * Tom Tat          :   Dinh nghia cac ham xu ly ADC 
  *           
  *
  ******************************************************************************
  * Chu Y          :
  *                                    
  ******************************************************************************
  */  

#include <main.h>
#include <ADC\adc.h>

// ==============================================================
unsigned int read_adc(unsigned char adc_input)
{
// Chon kenh, dien ap tham chieu, che do hoat dong cua ADC
ADMUX=adc_input | (ADC_VREF_TYPE & 0xff);
// Delay needed for the stabilization of the ADC input voltage
delay_us(10);
// Bat dau qua trinh chuyen doi
ADCSRA|=0x40;
// Cho ket thuc qua trinh chuyen doi
while ((ADCSRA & 0x10)==0);
ADCSRA|=0x10;
return ADCW;   // Tra ve gia tri ADC sau khi chuyen doi
}

// ==============================================================
void lcd_putnum(unsigned int N)
{
     unsigned int Nghin, Tram, Chuc, Donvi;
     Nghin = N/1000;
     Tram = (N%1000)/100;
     Chuc = (N%100)/10;
     Donvi = N%10;
     lcd_putchar(Nghin + 48);
     lcd_putchar(Tram + 48);
     lcd_putchar(Chuc + 48);
     lcd_putchar(Donvi + 48);
}

// ==============================================================
void adc()
{
     unsigned int i;
     i = read_adc(0);
     lcd_gotoxy(0,0);
     lcd_puts("  GIA TRI ADC:");
     lcd_gotoxy(6,1);
     lcd_putnum(i);
}
// ------------------END OF FILE-------------------
// ------------------------------------------------